//------------------------------------------------------------------------------------------------------------------------
// Console command - Help
//------------------------------------------------------------------------------------------------------------------------
void help()
{
	Sys.Print("");
	Sys.Print("----------Commands----------");
	Sys.Warning("call seed - Prints current Seed value to console");
	Sys.Warning("call time - Prints total Play Time to console");
}
//------------------------------------------------------------------------------------------------------------------------
// Prints current Seed value to console
//------------------------------------------------------------------------------------------------------------------------
void seed()
{
	Sys.Print("Current Seed: " + BPR::GameVar::GetInt(BPR::GV_KEY_START_SEED));
}
//------------------------------------------------------------------------------------------------------------------------
// Console command - Prints current Play Time
//------------------------------------------------------------------------------------------------------------------------
void time()
{
    kStr s = "Play Time: ";
    s += BPR::String::FormatHMMSSmm(BPR::Time::TicksToSeconds());
	Sys.Print(s);
}

//------------------------------------------------------------------------------------------------------------------------
void spawnchrono()
{
    kVec3 v = Player.Actor().Origin();
    kActor @actor = BPR::SpawnActor("ChronoPiece_1", v.x, v.y, v.z, 0.0f, Player.Actor().SectorIndex());
    actor.Scale().Set(0.35f, 0.35f, 0.35f);
    // actor.Flags() |= AF_SOLID | AF_CANBETOUCHED | AF_ALWAYSACTIVE;
    // actor.Flags() &= ~(AF_DORMANT|AF_DEAD|AF_DISABLED);
    // AF_HIDDEN
}
//------------------------------------------------------------------------------------------------------------------------
void spawnenemy()
{
    kVec3 v = Player.Actor().Origin();
    
    //BPR_SpawnAI_GruntAlt
    kActor @actor = BPR::SpawnActor("BPR_SpawnAI_Grunt", v.x, v.y, v.z, 0.0f, Player.Actor().SectorIndex());
    actor.Scale().Set(0.5f, 0.5f, 0.5f);
    //AF_STATIONARY | AF_WOUNDEDMORTALLY
    actor.Flags() |= AF_SOLID | AF_CASTSHADOW;
    actor.Flags() &= ~(AF_AVOIDWATER);
    switch(BPR::GetSpawnActorType(actor))
    {
    case AT_GRUNT:
        //random chance to add AF_WOUNDEDMORTALLY flag
        //random chance to add AF_STATIONARY flag and be a sniper (limit variants to weapon and stance types only)
        actor.ModelVariation() = Math::RandMax(GV_DEMON_LORD + 1);
        BPR::SetGruntTextures(actor);
        //Set Health depending on grunt type
        break;
    }
}
//------------------------------------------------------------------------------------------------------------------------
