namespace BPR
{
    kStr GV_SEP = "|";
    
    CL_BPR_MapData@ g_pMapData = CL_BPR_MapData();
    array<kStr> g_nsMapData;
    int g_iGetDataIndex = 0;
	//========================================================================================================================	
	class CL_BPR_MapData
	{
        array<CL_BPR_MapDataActor@> actors;
		CL_BPR_MapData()
		{
			
		}
	}
	//========================================================================================================================	
	class CL_BPR_MapDataActor
	{
        int iType;
        int iTID;
        kVec3 vStartPos;
        kVec3 vDestPos;
        int iDestSector;
		CL_BPR_MapDataActor()
		{
			
		}
	}
	//========================================================================================================================	
    bool HasMapData(const int iMapID)
    {
        kStr s;
        if(!GameVariables.GetString(GV_KEY_MAPDATA + iMapID, s))
        {
            return false;
        }
        
        return BPR::String::Length(s) > 1;
    }
	//------------------------------------------------------------------------------------------------------------------------
    int GetMapDataInt()
    {
        int i = g_nsMapData[g_iGetDataIndex].Atoi();
        g_iGetDataIndex++;
        return i;
    }
	//------------------------------------------------------------------------------------------------------------------------
    float GetMapDataFloat()
    {
        float f = g_nsMapData[g_iGetDataIndex].Atof();
        g_iGetDataIndex++;
        return f;
    }
	//------------------------------------------------------------------------------------------------------------------------
    bool LoadMapData(const int iMapID)
    {
        bool bLoaded = false;
        g_iGetDataIndex = 0;
        g_pMapData.actors.resize(0);
        
		kStr sMapsData;
        GameVariables.GetString(GV_KEY_MAPDATA + iMapID, sMapsData);
		g_nsMapData = BPR::String::Split(sMapsData, GV_SEP);
        
        if(g_nsMapData.length() > 1)
        {
            bLoaded = true;
            g_pMapData.actors.resize(GetMapDataInt());
            for(uint i = 0; i < g_pMapData.actors.length(); ++i)
            {
                @g_pMapData.actors[i] = CL_BPR_MapDataActor();
                CL_BPR_MapDataActor@ a = g_pMapData.actors[i];
                a.iType = GetMapDataInt();
                a.iTID = GetMapDataInt();
                a.vStartPos.x = GetMapDataFloat();
                a.vStartPos.y = GetMapDataFloat();
                a.vStartPos.z = GetMapDataFloat();
                a.vDestPos.x = GetMapDataFloat();
                a.vDestPos.y = GetMapDataFloat();
                a.vDestPos.z = GetMapDataFloat();
                a.iDestSector = GetMapDataInt();
            }
        }
        
        g_nsMapData.resize(0);
        return bLoaded;
    }
	//------------------------------------------------------------------------------------------------------------------------
    void SaveMapData(const int iMapID)
    {
        kStr result;
        result = "" + g_pMapData.actors.length();
        for(uint i = 0; i < g_pMapData.actors.length(); ++i)
        {
            CL_BPR_MapDataActor@ a = g_pMapData.actors[i];
            result += GV_SEP + a.iType;
            result += GV_SEP + a.iTID;
            result += GV_SEP + a.vStartPos.x + GV_SEP + a.vStartPos.y + GV_SEP + a.vStartPos.z;
            result += GV_SEP + a.vDestPos.x + GV_SEP + a.vDestPos.y + GV_SEP + a.vDestPos.z;
            result += GV_SEP + a.iDestSector;
        }
        
        if(!GameVariables.HasKey(GV_KEY_MAPDATA + iMapID))
        {
            GameVariables.Add(GV_KEY_MAPDATA + iMapID, result);
        }
        else
        {
            GameVariables.SetValue(GV_KEY_MAPDATA + iMapID, result);
        }
    }
	//------------------------------------------------------------------------------------------------------------------------
}
