namespace BPR { namespace Math
{
	const uint UBIT31 = 2147483648;
	const int MIN_INT = -2147483648;
	const int MAX_INT = 2147483647;
	const uint MAX_UINT = 4294967295;
	//------------------------------------------------------------------------------------------------------------------------
	int Clamp(const int value, const int min, const int max)
	{
		return (value < min) ? min : ((value > max) ? max : value);
	}
	//------------------------------------------------------------------------------------------------------------------------
	float Clampf(const float value, const float min, const float max)
	{
		return (value < min) ? min : ((value > max) ? max : value);
	}
	//------------------------------------------------------------------------------------------------------------------------
	float Min(const float a, const float b)
	{
		return (a < b) ? a : b;
	}
	//------------------------------------------------------------------------------------------------------------------------
	float Max(const float a, const float b)
	{
		return (a > b) ? a : b;
	}
	//------------------------------------------------------------------------------------------------------------------------
	int Min(const int a, const int b)
	{
		return (a < b) ? a : b;
	}
	//------------------------------------------------------------------------------------------------------------------------
	int Max(const int a, const int b)
	{
		return (a > b) ? a : b;
	}
	//------------------------------------------------------------------------------------------------------------------------
	float SmoothStepFloat(const float from, const float to, float t)
	{
		t = Clampf(t, 0.0f, 1.0f);
		t = -2.0f * t * t * t + 3.0f * t * t;
		return to * t + from * (1.0f - t);
	}
	//------------------------------------------------------------------------------------------------------------------------
	kVec3 SmoothStepVec3(const kVec3 &in from, const kVec3 &in to, float t)
	{
		t = -2.0f * t * t * t + 3.0f * t * t;
		float it = 1.0f - t;
		return kVec3(to.x * t + from.x * it, to.y * t + from.y * it, to.z * t + from.z * it);
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Returns an array of digits from the unsigned integer
	//------------------------------------------------------------------------------------------------------------------------
	array<int> Digits(const uint n, const bool reverse = false)
	{
		if (n == 0)
			return array<int> = {0};
		
		uint num = n;
		array<int> digits;
		while (num > 0)
		{
			digits.insertLast(num % 10);
			num /= 10;
		}
		if (!reverse)
			digits.reverse();
		return digits;
	}
}}
