namespace BPR
{
    int g_iRandSeed;
	//------------------------------------------------------------------------------------------------------------------------
	// Sets the random seed value to iSeed
	//------------------------------------------------------------------------------------------------------------------------
    void SetRandSeed(const int iSeed)
    {
        g_iRandSeed = iSeed;
    }
	//------------------------------------------------------------------------------------------------------------------------
	// -2147483648 .. 2147483647
	//------------------------------------------------------------------------------------------------------------------------
	int Rand()
	{
        SetRandSeed(Rand(g_iRandSeed));
        return g_iRandSeed;
	}
	//------------------------------------------------------------------------------------------------------------------------
	// -2147483648 .. 2147483647
	//------------------------------------------------------------------------------------------------------------------------
	int Rand(const int iSeed)
	{
		return iSeed * 103515245 + 12345;
	}
	//------------------------------------------------------------------------------------------------------------------------
	// 0 .. max-1
	//------------------------------------------------------------------------------------------------------------------------
	int RandMax(const uint max)
	{
		return Math::Abs(Rand()) % max;
	}
	//------------------------------------------------------------------------------------------------------------------------
	// 0 .. max-1
	//------------------------------------------------------------------------------------------------------------------------
	int RandMax(const int iSeed, const uint max)
	{
		return Math::Abs(iSeed) % max;
	}
	//------------------------------------------------------------------------------------------------------------------------
	// -1.0f .. 1.0f
	//------------------------------------------------------------------------------------------------------------------------
	float RandCFloat()
	{
		return Rand() / 2147483648.0f;
	}
	//------------------------------------------------------------------------------------------------------------------------
	// -1.0f .. 1.0f
	//------------------------------------------------------------------------------------------------------------------------
	float RandCFloat(const int iSeed)
	{
		return iSeed / 2147483648.0f;
	}
	//------------------------------------------------------------------------------------------------------------------------
	// 0.0f .. 1.0f
	//------------------------------------------------------------------------------------------------------------------------
	float RandFloat()
	{
		return Math::Abs(Rand()) / 2147483647.0f;
	}
	//------------------------------------------------------------------------------------------------------------------------
	// 0.0f .. 1.0f
	//------------------------------------------------------------------------------------------------------------------------
	float RandFloat(const int iSeed)
	{
		return Math::Abs(iSeed) / 2147483647.0f;
	}
	//------------------------------------------------------------------------------------------------------------------------
	float RandFloatRange(const float a, const float b)
	{
		float f = Math::Abs(Rand()) / 2147483647.0f;
		return (1.0f - f) * b + f * a;
	}
	//------------------------------------------------------------------------------------------------------------------------
	float RandFloatRange(const int iSeed, const float a, const float b)
	{
		float f = Math::Abs(iSeed) / 2147483647.0f;
		return (1.0f - f) * b + f * a;
	}
	//------------------------------------------------------------------------------------------------------------------------
}
