namespace BPR { namespace Time
{
	//------------------------------------------------------------------------------------------------------------------------
	float TicksToSeconds(const int ticks)
	{
		return ticks * GAME_DELTA_TIME;
	}
	//------------------------------------------------------------------------------------------------------------------------
	float TicksToSeconds()
	{
		return TicksToSeconds(Ticks());
	}
	//------------------------------------------------------------------------------------------------------------------------
	int Now(const int iTickOffset)
	{
		return Ticks() + iTickOffset;
	}
	//------------------------------------------------------------------------------------------------------------------------
	int Diff(const int iTicks)
	{
		return Math::Abs(Ticks() - iTicks);
	}
	//------------------------------------------------------------------------------------------------------------------------
	bool Reached(const int iTicks)
	{
		return Ticks() >= iTicks;
	}
	//------------------------------------------------------------------------------------------------------------------------
	int Ticks()
	{
		return BPR::GameVar::GetInt(GV_KEY_TICKS);
	}
	//------------------------------------------------------------------------------------------------------------------------
	float Normalize(const int from, const int to)
	{
		int length = to - from;
		if(length <= 0)
        {
			return 1.0f;
        }
		
		return BPR::Math::Clampf(Diff(from) / float(length), 0.0f, 1.0f);
	}
	//------------------------------------------------------------------------------------------------------------------------
    void Tick()
    {
        GameVariables.SetValue(GV_KEY_TICKS, "" + (Ticks() + 1));
    }
	//------------------------------------------------------------------------------------------------------------------------
}}
